CUI.MyAccount = {
    init : function(){
        var self = this;
        CUI.Globals.ActiveView = 'myaccount';
        self._bindEvents();
    },
    _bindEvents : function(){
        var self = this;
        self.resetPasswordModal = CUI.Utils.modalDialog('#change-password-dlg');

        $('.reactivate-client').click(function(){            
            var response = CUI.RPC.callmethod('myaccount.reactivateClient');
        });

        $('#btn-change-password').click(function(e){
            e.preventDefault();

            self.resetPasswordDlg();
            self.resetPasswordModal.show();
            // show loader until password policy is fetched
            $('.pwdPolicySpinnerImg').show();
            $('#user-password').focus();
            $('.passwordNote').html('');
            CUI.RPC.callmethod('myaccount.getPwdPolicy');

            // Poll readPwdPolicy
            var readPwdPolicyInterval = setInterval(function(){
                var response = CUI.RPC.callmethod('myaccount.readPwdPolicy');
                if( response['status'] === 0 || response['status'] === -1 ){
                    $('.passwordNote').html(response['msg']);
                    $('.pwdPolicySpinnerImg').hide();
                    clearInterval(readPwdPolicyInterval);
                }
            }, 1000);            
        });

        $('.druva-home-help-link').click(function(e){
            e.preventDefault();
            CUI.RPC.callmethod('myaccount.openDruvaHomeLink');            
        });

        $('#btn-save-password').click(function(e){
            e.preventDefault();
            self.changePassword();
            return false;
        });

        $('#data-privacy-settings').change(function() {
            self.updateDataPrivacySettings();
        });
    },

    changePassword: function(){
        var self = this;
        var data  = {};        
        data['rpassword'] = $('#retry-user-password').val();
        data['password'] = $('#user-password').val();
        // To get the translated message in case of some checks failure,
        // let cuiserver perform comparision.
        var response = CUI.RPC.callmethod('myaccount.changePassword', data);
        if (response['status'] == -1){
            /*Since \n tag not working and translations files cannot have <br/> tag */
            response['msg']=response['msg'].replace(/\n/g, "<br />");
            CUI.Utils.alertDialog({message: response['msg']});
            $('#user-password').focus();
        } else {
            var dlg =CUI.Utils.alertDialog({message: response['msg']});
            self.resetPasswordModal.hide();
            dlg.getContent().find('#Ok').focus();
        }
        self.resetPasswordDlg();
    },
    resetPasswordDlg: function(){
        $('#user-password').val('');
        $('#retry-user-password').val('');                
    },
    _updatePrivacyCheckbox: function(disableSrvRestore){
        if (disableSrvRestore) {
            $("#privacy-select").removeAttr('checked');
        } else {
            $("#privacy-select").attr('checked', 'checked');
        }
    },
    updateDataPrivacySettings: function(){
        var msgCofirm, msgAlert,  self = this,
        data = {},
        disableSrvRestore = ! $("#privacy-select").is(':checked');
        self._updatePrivacyCheckbox(!disableSrvRestore);
        data['disable'] = disableSrvRestore;
        if(disableSrvRestore){
            msgCofirm = CUI._('Do you want to disallow administrators to view or download your data?');
            msgAlert = CUI._('Successfully updated privacy settings - administrators can not view or download your data.');
        } else{
            msgCofirm = CUI._('Do you want to allow administrators to view or download your data?');
            msgAlert = CUI._('Successfully updated privacy settings - administrators can view or download your data.');
        }
        CUI.Utils.alertDialog({
            message: msgCofirm,
            buttons: {
                'No': function() {},
                'Yes': function(){
                    var response = CUI.RPC.callmethod('myaccount.disableSrvRestore', data);
                    self._updatePrivacyCheckbox(response['disabled']);
                    if(response['status'] == -1){
                        CUI.Utils.alertDialog({message: response['msg']});
                    } else {
                        CUI.Utils.alertDialog({message: msgAlert});
                    }
                }
            }
        });
    },
};

